/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"

#include <assert.h>

#include <stdio.h> // files
#include <io.h>

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <wchar.h>

#define PN_MIDI_IN  0
#define PN_ECHO     1
#define PN_CUT      2
#define PN_MIDI_OUT 3

#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90

void Module::sub_process(long buffer_offset, long sampleFrames )
{ 
	
	sind = 24;
	while (sind--)
	{
		if(does[sind] == true )
		{
	if (p_clock2[sind] <= SampleClock() )
	{
	    
	    int chan = midi_msg2[sind] & 0x0f;
		int stat = midi_msg2[sind] & 0xf0;
		int b2 = ( midi_msg2[sind] / 0x100 ) & 0xff;
	    int b3 = ( midi_msg2[sind] / 0x10000 ) & 0xff;  


        b3 = (int) ( b3 * cut ) / 101 ;
        if ((b3 <= 0 )&&(son == true))
		{
			b3 = 0;
			stat = NOTE_OFF;
            midi_msg2[sind] = chan + stat  + (b2 << 8) + (b3 << 16);
            getPin(PN_MIDI_OUT)->TransmitMIDI( p_clock2[sind] + transpose_ammount * 2 * 1000, midi_msg2[sind] );
		    son = false;
			does[sind] = false;
		}
        midi_msg2[sind] =  chan + stat  + (b2 << 8) + (b3 << 16);


	    if ((b3 > 0 )&&(stat == NOTE_ON))
		{
		  getPin(PN_MIDI_OUT)->TransmitMIDI( p_clock2[sind]+1, midi_msg2[sind] );
	      p_clock2[sind] = SampleClock() +  transpose_ammount * 1000;
		  son = true;
		}
	}
	}
	}
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
 bool is_system_msg = ( midi_msg & SYSTEM_MSG ) == SYSTEM_MSG;

	if( !is_system_msg )
	{
		// The first byte of a midi message contains the status (note on/off etc) and the channel
		int chan = midi_msg & 0x0f;
		int stat = midi_msg & 0xf0;

		// the next two bytes depend on the type of message
		int b2 = ( midi_msg / 0x100 ) & 0xff;
		int b3 = ( midi_msg / 0x10000 ) & 0xff;

		switch( stat )
		{
		case NOTE_ON:
		//case NOTE_OFF:
			

			// re-assemble the MIDI message into an 32 bit integer
			midi_msg = stat + chan + (b2 << 8) + (b3 << 16);
			midi_msg2[ist] = midi_msg;  
	// send the MIDI
	getPin(PN_MIDI_OUT)->TransmitMIDI( p_clock, midi_msg );
	if(transpose_ammount > 0)
	{
		p_clock2[ist] = p_clock + (transpose_ammount*1000);
	
	    does[ist] = true;
        if(ist++ > 24) ist = 0;
	}
    

			break;
		}
	}


	
}
/*
		// The first byte of a midi message contains the status (note on/off etc) and the channel
		int chan = midi_msg & 0x0f;//channel
		int stat = midi_msg & 0xf0;//on off
		// the next two bytes depend on the type of message
		int b2 = ( midi_msg / 0x100 ) & 0xff; // note
		int b3 = ( midi_msg / 0x10000 ) & 0xff; // velo
        */
Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{   
	son = true;
	SEModule_base::open();
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{ 
   LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n",  "MIDI_echo2");
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = dish.thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = dish.thisSEM;

	// Info, may include Author, Web page whatever
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;
  
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	case 0:
		properties->name				= "MIDI In";
		properties->direction			= DR_IN;
		properties->datatype			= DT_MIDI2;
		break;
    case 1:
		properties->name				= "time";
		properties->variable_address	= &transpose_ammount;
		properties->datatype_extra		= "range 0, 4444";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 2:
		properties->name				= "cut";
		properties->variable_address	= &cut;
		properties->datatype_extra		= "range 1,100";
		properties->default_value		= "50";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;


/*
    case 1:	
		properties->name				= "REDUCE";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->datatype_extra      = "1,10,1,10";
		properties->default_value		= "0";
		break;
    case 2:	
		properties->name				= "ADD";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
*/  
  case 3:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;

	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}


void Module::OnPlugStateChange(SEPin *pin)
{ 
	   
}